package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.Banner;
import com.izouma.dingdong.service.backstage.BannerService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.BannerRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/banner")
@AllArgsConstructor
public class BannerController extends BaseController {
    private BannerService bannerService;
    private BannerRepo bannerRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Banner save(@RequestBody Banner record) {
        if (record.getId() != null) {
            Banner orig = bannerRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return bannerRepo.save(orig);
        }
        return bannerRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Banner> all(PageQuery pageQuery) {
        return bannerRepo.findAll(toSpecification(pageQuery,Banner.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Banner get(@PathVariable Long id) {
        return bannerRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        bannerRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Banner> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

